'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames3 = require('classnames');

var _classnames4 = _interopRequireDefault(_classnames3);

var _iscrollProbe = require('iscroll/build/iscroll-probe.js');

var _iscrollProbe2 = _interopRequireDefault(_iscrollProbe);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Scroll = function (_Component) {
  _inherits(Scroll, _Component);

  function Scroll(props) {
    _classCallCheck(this, Scroll);

    var _this = _possibleConstructorReturn(this, (Scroll.__proto__ || Object.getPrototypeOf(Scroll)).call(this, props));

    _this.wH = document.documentElement.clientHeight || window.innerHeight;
    _this.state = {
      myScroll: null,
      minHeight: _this.wH - 150,
      downStatus: 0,
      upStatus: 0,
      initSuccess: false //初始化完成 默认false
    };
    _this.pullDownTips = {
      // 下拉状态
      0: '下拉刷新',
      1: '松手刷新',
      2: '正在刷新',
      3: '刷新成功'
    };

    _this.pullUpTips = {
      // 上拉状态
      0: '上拉加载',
      1: '松手加载',
      2: '正在加载',
      3: '加载成功'
    };
    _this.downFlag = false;
    _this.upFlag = false;
    _this.fetchComplete = _this.fetchComplete.bind(_this);
    _this.fetchJsons = _this.fetchJsons.bind(_this);

    /*
     * this.props 参数说明
     * openDown = true 开启 下拉刷新  ，默认 false 
     * openUp = true 开启 上拉加载更多  ，默认 false 
     * allowScroll 允许滚动 ，这里的滚动，指的是页面全局的滚动，默认 true ,
     * downFetch '下拉刷新' 达到条件调用的方法 ,
     * upFetch '上拉加载更多' 达到条件调用的方法 ,
     * isRefresh '下拉、上拉 加载完成' 更新视图 , 默认false ,fetch调用完成时请更新为true
     * onScroll iscroll滚动时的信息监听，默认无
    */

    return _this;
  }

  _createClass(Scroll, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      setTimeout(function () {
        _this2.state.myScroll = new _iscrollProbe2.default(_this2.refs.scrollWrapper, {
          mouseWheel: true,
          probeType: 3,
          bounce: true,
          preventDefault: false,
          disablePointer: false,
          scrollbars: _this2.props.scrollbar
        });

        _this2.stopTouchmove = function (e) {
          e.preventDefault();
        };
        _this2.state.myScroll.on('scroll', function () {
          var _state = _this2.state,
              myScroll = _state.myScroll,
              downStatus = _state.downStatus,
              upStatus = _state.upStatus;
          var _props = _this2.props,
              openDown = _props.openDown,
              openUp = _props.openUp;

          var y = myScroll.y,
              maxY = myScroll.maxScrollY - y;
          //下拉刷新 的监听
          if (openDown) {
            if (y >= 45) {
              if (!downStatus) {
                _this2.setState({
                  downStatus: 1
                });
              }
              return false;
            } else if (y < 45 && y > 0 && !_this2.downFlag) {
              if (downStatus) {
                _this2.setState({
                  downStatus: 0
                });
              }
              return false;
            }
          };

          //上拉加载 的监听
          if (openUp) {
            if (maxY >= 45) {
              if (!upStatus) {
                _this2.setState({
                  upStatus: 1
                });
              }
              return false;
            } else if (maxY < 45 && maxY >= 0 && !_this2.upFlag) {
              if (upStatus) {
                _this2.setState({
                  upStatus: 0
                });
              }
              return false;
            };
          };
          _this2.props.onScroll && _this2.props.onScroll(_this2.state.myScroll);
        });

        //监听 touchend 结束的事件
        _this2.refs.scrollWrapper.addEventListener('touchend', function () {
          var _state2 = _this2.state,
              downStatus = _state2.downStatus,
              upStatus = _state2.upStatus,
              myScroll = _state2.myScroll;
          var _props2 = _this2.props,
              openDown = _props2.openDown,
              openUp = _props2.openUp,
              downFetch = _props2.downFetch,
              upFetch = _props2.upFetch;


          if (openDown || openUp) {

            //下拉刷新
            console.log("down touchend", _this2.state.downStatus, myScroll.directionY);
            if (downStatus == 1 && myScroll.directionY <= 1) {
              _this2.downFlag = true;
              _this2.setState({ downStatus: 2 });

              // this.state.myScroll.scrollTo(0, -1 * 40, 200);
              downFetch && _this2.fetchJsons(downFetch);
              // downFetch&&downFetch(this.fetchComplete).then(()=>{
              //   __DEBUG__ && console.log("openDown 请求完成");
              //   this.fetchComplete();
              // });
            } else if (upStatus == 1 && myScroll.directionY <= 1) {
              //上拉加载
              _this2.upFlag = true;
              _this2.setState({ upStatus: 2 });
              // this.state.myScroll.scrollTo(0, myScroll.maxScrollY + 80, 150);
              upFetch && _this2.fetchJsons(upFetch);
              // upFetch&&upFetch(this.fetchComplete).then(()=>{
              //   __DEBUG__ && console.log("openUp 请求完成");
              //   this.fetchComplete();
              // });
              // console.log("up - touchend",this.state.upStatus);
            }
          };
        });
        var allowScroll = _this2.props.allowScroll;
        if (!allowScroll) {
          _this2.refs.scrollWrapper.addEventListener('touchmove', _this2.stopTouchmove);
          document.addEventListener('touchmove', _this2.stopTouchmove);
        };
        _this2.ininData();
      }, 250);
    }
  }, {
    key: 'fetchJsons',
    value: function fetchJsons(callBack) {
      var _this3 = this;

      /*
        调用下拉、上拉 方法，统一处理回调 
       * downFetch '下拉刷新'  ,
       * upFetch '上拉加载更多'  ,
      */
      var re = /function\s*(\w*)/i;
      var matches = re.exec('' + callBack);
      callBack && callBack(this.fetchComplete).then(function () {

        __DEBUG__ && console.log((matches && matches[0]) + ' --- \u8BF7\u6C42\u5B8C\u6210');
        _this3.fetchComplete();
      }, function () {
        __DEBUG__ && console.log((matches && matches[0]) + ' --- \u8BF7\u6C42\u5F02\u5E38');
        _this3.fetchComplete();
      });
    }
  }, {
    key: 'ininData',
    value: function ininData() {
      /*
        *初始化时 检测，如有设置，默认调用一次下拉、或下拉方法，加载数据
      */
      var _props3 = this.props,
          openDown = _props3.openDown,
          openUp = _props3.openUp,
          downFetch = _props3.downFetch,
          upFetch = _props3.upFetch;


      if (openDown && downFetch) {
        this.fetchJsons(downFetch);
        // downFetch(this.fetchComplete).then(()=>{
        //   __DEBUG__ && console.log("openDown 请求完成");
        //   this.fetchComplete();
        // })
      } else if (openUp && upFetch) {
        this.fetchJsons(upFetch);
        // upFetch(this.fetchComplete).then(()=>{
        //   __DEBUG__ && console.log("openUp 请求完成");
        //   this.fetchComplete();
        // });
      } else {
        this.fetchComplete();
      };
    }
  }, {
    key: 'manualTouchMove',
    value: function manualTouchMove(allowScroll) {
      if (allowScroll) {
        document.removeEventListener('touchmove', this.stopTouchmove);
      } else {
        document.addEventListener('touchmove', this.stopTouchmove);
      }
    }
  }, {
    key: 'fetchComplete',
    value: function fetchComplete() {
      //fetch 完成时的请求回调
      var _state3 = this.state,
          downStatus = _state3.downStatus,
          upStatus = _state3.upStatus,
          myScroll = _state3.myScroll;

      var minH = (this.refs.scrollWrapper && this.refs.scrollWrapper.clientHeight || this.wH - 150) + 5;
      if (downStatus == 2 || this.downFlag) {
        this.setState({
          downStatus: 3,
          minHeight: minH
        });
      } else if (upStatus == 2 || this.upFlag) {
        this.setState({
          upStatus: 3,
          minHeight: minH
        });
      } else {
        this.setState({
          downStatus: 3,
          minHeight: minH,
          initSuccess: true
        });
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      var _this4 = this;

      var _props4 = this.props,
          openDown = _props4.openDown,
          openUp = _props4.openUp,
          isRefresh = _props4.isRefresh;
      var _state4 = this.state,
          downStatus = _state4.downStatus,
          upStatus = _state4.upStatus,
          myScroll = _state4.myScroll;

      var preRefresh = prevProps.isRefresh;
      //未开启 上拉、下拉 时 自动更新
      if (!openDown && !openUp) {
        setTimeout(function () {
          myScroll.refresh();
        }, 350);
      } else if (openDown || openUp) {
        if (downStatus == 3) {
          this.setState({ downStatus: 0 });
          setTimeout(function () {
            myScroll.refresh();
            _this4.downFlag = false;
            __DEBUG__ && console.log("dow 视图更新了");
          }, 350);
        } else if (upStatus == 3) {
          this.setState({ upStatus: 0 });
          setTimeout(function () {
            myScroll.refresh();
            _this4.upFlag = false;
            __DEBUG__ && console.log("up 上拉加载 视图更新了");
          }, 350);
        } else if (isRefresh != preRefresh) {
          setTimeout(function () {
            myScroll.scrollTo(0, 0);
            myScroll.refresh();
          }, 350);
        };
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _this5 = this;

      this.manualTouchMove(nextProps.allowScroll);
      if (nextProps.refresh) {
        setTimeout(function () {
          _this5.state.myScroll && _this5.state.myScroll.refresh();
        }, 150);
      }
      var ScrollToY = nextProps.ScrollToY;


      if (!ScrollToY || this.updateY == nextProps.updateY) {
        return;
      }

      this.updateY = nextProps.updateY;

      this.state.myScroll.scrollTo(0, -ScrollToY, 500);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.refs.scrollWrapper.removeEventListener('touchmove', this.stopTouchmove);
      this.refs.scrollWrapper.removeEventListener('touchend', this.stopTouchmove);
      document.removeEventListener('touchmove', this.stopTouchmove);
    }
  }, {
    key: 'render',
    value: function render() {
      var _state5 = this.state,
          downStatus = _state5.downStatus,
          upStatus = _state5.upStatus,
          initSuccess = _state5.initSuccess,
          minHeight = _state5.minHeight;

      var props = this.props;

      var children = props.children,
          className = props.className,
          openDown = props.openDown,
          openUp = props.openUp,
          others = _objectWithoutProperties(props, ['children', 'className', 'openDown', 'openUp']);

      return _react2.default.createElement(
        'div',
        { className: 'scroll-wrapper', ref: 'scrollWrapper' },
        _react2.default.createElement(
          'div',
          { className: 'scroller' },
          openDown ? _react2.default.createElement(
            'div',
            { className: (0, _classnames4.default)("s-pullDown", { 'init': initSuccess }) },
            _react2.default.createElement(
              'em',
              { className: (0, _classnames4.default)("scroll-svg", _defineProperty({}, 'step' + downStatus, true)) },
              '\u3000'
            ),
            _react2.default.createElement(
              'em',
              { className: 'scroll-msg' },
              this.pullDownTips[downStatus]
            )
          ) : null,
          _react2.default.createElement(
            'div',
            { className: 'iscroll-child', style: { minHeight: minHeight } },
            children
          ),
          openUp ? _react2.default.createElement(
            'div',
            { className: (0, _classnames4.default)("s-pullUp", { 'init': initSuccess }) },
            _react2.default.createElement(
              'em',
              { className: (0, _classnames4.default)("scroll-svg", _defineProperty({}, 'step' + upStatus, true)) },
              '\u3000'
            ),
            _react2.default.createElement(
              'em',
              { className: 'scroll-msg' },
              this.pullUpTips[upStatus]
            )
          ) : null
        )
      );
    }
  }]);

  return Scroll;
}(_react.Component);

;

exports.default = Scroll;