'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _Mask = require('../Mask');

var _Mask2 = _interopRequireDefault(_Mask);

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _Toast = require('../Toast');

var _Toast2 = _interopRequireDefault(_Toast);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var StaticToast = {
  default: function _default(message, callback, duration, theme) {
    var div = document.createElement('div');
    document.body.appendChild(div);
    _reactDom2.default.render(_react2.default.createElement(
      _Toast2.default,
      {
        duration: duration || 3500,
        visible: true,
        onMaskClick: function onMaskClick() {
          _reactDom2.default.unmountComponentAtNode(div);
          document.body.removeChild(div);
          callback && callback();
        } },
      _react2.default.createElement(_Icon2.default, { type: theme || "close-round", style: { fontSize: '3rem' } }),
      _react2.default.createElement(
        'p',
        null,
        message
      )
    ), div);
  },
  info: function info(message, callback, duration) {
    StaticToast.default(message, callback, duration);
  },

  success: function success(message, callback, duration) {
    StaticToast.default(message, callback, duration, "right-round-fill");
  },

  warning: function warning(message, callback, duration) {
    StaticToast.default(message, callback, duration);
  },

  error: function error(message, callback, duration) {
    StaticToast.default(message, callback, duration, "close-round");
  }
};
// import {Mask, Icon, Toast} from 'pxb-mobile-ui';
exports.default = StaticToast;